]> git.cworth.org Git - notmuch/blob - test/test-lib.sh
4eb58ea0a29a4e8c08ec6869b479d5e07588967a
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 . "$NOTMUCH_SRCDIR/test/test-vars.sh" || exit 1
68
69 add_gnupg_home () {
70     [ -e "${GNUPGHOME}/gpg.conf" ] && return
71     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
72     at_exit_function _gnupg_exit
73     mkdir -p -m 0700 "$GNUPGHOME"
74     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
75     test_debug "cat $GNUPGHOME/import.log"
76     if (gpg --quick-random --version >/dev/null 2>&1) ; then
77         echo quick-random >> "$GNUPGHOME"/gpg.conf
78     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
79         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
80     fi
81     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
82
83     # Change this if we ship a new test key
84     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
85     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
86     SELF_EMAIL="test_suite@notmuchmail.org"
87     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
88 }
89
90 add_gpgsm_home () {
91     test_require_external_prereq openssl
92
93     local fpr
94     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
95     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
96     at_exit_function _gnupg_exit
97     mkdir -p -m 0700 "$GNUPGHOME"
98     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
99           --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<'' <$NOTMUCH_SRCDIR/test/smime/0xE0972A47.p12
100     fpr=$(gpgsm --batch --with-colons --list-key test_suite@notmuchmail.org | awk -F: '/^fpr/ {print $10}')
101     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
102     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
103     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
104     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
105     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
106               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
107     test_debug "cat $GNUPGHOME/import.log"
108 }
109
110 # Each test should start with something like this, after copyright notices:
111 #
112 # test_description='Description of this test...
113 # This test checks if command xyzzy does the right thing...
114 # '
115 # . ./test-lib.sh || exit 1
116
117 color=maybe
118
119 while test "$#" -ne 0
120 do
121         case "$1" in
122         -d|--debug)
123                 debug=t; shift ;;
124         -i|--immediate)
125                 immediate=t; shift ;;
126         -h|--help)
127                 help=t; shift ;;
128         -v|--verbose)
129                 verbose=t; shift ;;
130         -q|--quiet)
131                 quiet=t; shift ;;
132         --with-dashes)
133                 with_dashes=t; shift ;;
134         --no-color)
135                 color=; shift ;;
136         --no-python)
137                 # noop now...
138                 shift ;;
139         --valgrind)
140                 valgrind=t; verbose=t; shift ;;
141         --tee)
142                 shift ;; # was handled already
143         *)
144                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
145         esac
146 done
147
148 if test -n "$debug"; then
149         fmt_subtest () {
150                 printf -v $1 " %-4s" "[$((test_count - 1))]"
151         }
152 else
153         fmt_subtest () {
154                 printf -v $1 ''
155         }
156 fi
157
158 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
159
160 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] &&
161         tput -T "$ORIGINAL_TERM" -S <<<$'bold\nsetaf\nsgr0\n' >/dev/null 2>&1
162 then
163         color=t
164 else
165         color=
166 fi
167
168 if test -n "$color"
169 then
170         # _tput run in subshell (``) only
171         _tput () { exec tput -T "$ORIGINAL_TERM" "$@"; }
172         unset BOLD RED GREEN BROWN SGR0
173         say_color () {
174                 case "$1" in
175                         error)  b=${BOLD=`_tput bold`}
176                                 c=${RED=`_tput setaf 1`}   ;; # bold red
177                         skip)   b=${BOLD=`_tput bold`}
178                                 c=${GREEN=`_tput setaf 2`} ;; # bold green
179                         pass)   b= c=${GREEN=`_tput setaf 2`} ;; # green
180                         info)   b= c=${BROWN=`_tput setaf 3`} ;; # brown
181                         *) b= c=; test -n "$quiet" && return ;;
182                 esac
183                 f=$2
184                 shift 2
185                 sgr0=${SGR0=`_tput sgr0`}
186                 fmt_subtest st
187                 printf " ${b}${c}${f}${sgr0}${st}" "$@"
188         }
189 else
190         say_color() {
191                 test -z "$1" && test -n "$quiet" && return
192                 f=$2
193                 shift 2
194                 fmt_subtest st
195                 printf " ${f}${st}" "$@"
196         }
197 fi
198
199 error () {
200         say_color error "error: $*\n"
201         GIT_EXIT_OK=t
202         exit 1
203 }
204
205 say () {
206         say_color info "$*"
207 }
208
209 test "${test_description}" != "" ||
210 error "Test script did not set test_description."
211
212 if test "$help" = "t"
213 then
214         echo "Tests ${test_description}"
215         exit 0
216 fi
217
218 test_description_printed=
219 print_test_description () {
220         test -z "$test_description_printed" || return 0
221         echo
222         echo $this_test: "Testing ${test_description}"
223         test_description_printed=1
224 }
225 if [ -z "$NOTMUCH_TEST_QUIET" ]
226 then
227         print_test_description
228 fi
229
230 test_failure=0
231 test_count=0
232 test_fixed=0
233 test_broken=0
234 test_success=0
235
236 declare -a _exit_functions=()
237
238 at_exit_function () {
239         _exit_functions=($1 ${_exit_functions[@]/$1})
240 }
241
242 rm_exit_function () {
243         _exit_functions=(${_exit_functions[@]/$1})
244 }
245
246 _exit_common () {
247         code=$?
248         trap - EXIT
249         set +ex
250         for _fn in ${_exit_functions[@]}; do $_fn; done
251         rm -rf "$TEST_TMPDIR"
252 }
253
254 trap_exit () {
255         _exit_common
256         if test -n "$GIT_EXIT_OK"
257         then
258                 exit $code
259         else
260                 exec >&6
261                 say_color error '%-6s' FATAL
262                 echo " $test_subtest_name"
263                 echo
264                 echo "Unexpected exit while executing $0. Exit code $code."
265                 exit 1
266         fi
267 }
268
269 trap_signal () {
270         _exit_common
271         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
272         exit $code
273 }
274
275 die () {
276         _exit_common
277         exec >&6
278         say_color error '%-6s' FATAL
279         echo " $*"
280         echo
281         echo "Unexpected exit while executing $0."
282         exit 1
283 }
284
285 trap 'trap_exit' EXIT
286 trap 'trap_signal' HUP INT TERM
287
288 # Add an existing, fixed corpus of email to the database.
289 #
290 # $1 is the corpus dir under corpora to add, using "default" if unset.
291 #
292 # The default corpus is based on about 50 messages from early in the
293 # history of the notmuch mailing list, which allows for reliably
294 # testing commands that need to operate on a not-totally-trivial
295 # number of messages.
296 add_email_corpus () {
297     local corpus
298     corpus=${1:-default}
299
300     rm -rf ${MAIL_DIR}
301     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
302     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
303 }
304
305 test_begin_subtest () {
306     if [ -n "$inside_subtest" ]; then
307         exec 1>&6 2>&7          # Restore stdout and stderr
308         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
309     fi
310     test_subtest_name="$1"
311     test_reset_state_
312     # Redirect test output to the previously prepared file descriptors
313     # 3 and 4 (see below)
314     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
315     exec >&3 2>&4
316     inside_subtest=t
317 }
318
319 # Pass test if two arguments match
320 #
321 # Note: Unlike all other test_expect_* functions, this function does
322 # not accept a test name. Instead, the caller should call
323 # test_begin_subtest before calling this function in order to set the
324 # name.
325 test_expect_equal () {
326         local output expected testname
327         exec 1>&6 2>&7          # Restore stdout and stderr
328         if [ -z "$inside_subtest" ]; then
329                 error "bug in the test script: test_expect_equal without test_begin_subtest"
330         fi
331         inside_subtest=
332         test "$#" = 2 ||
333         error "bug in the test script: not 2 parameters to test_expect_equal"
334
335         output="$1"
336         expected="$2"
337         if ! test_skip "$test_subtest_name"
338         then
339                 if [ "$output" = "$expected" ]; then
340                         test_ok_
341                 else
342                         testname=$this_test.$test_count
343                         echo "$expected" > $testname.expected
344                         echo "$output" > $testname.output
345                         test_failure_ "$(diff -u $testname.expected $testname.output)"
346                 fi
347     fi
348 }
349
350 test_diff_file_ () {
351     local file1 file2 testname basename1 basename2
352     file1="$1"
353     file2="$2"
354     if ! test_skip "$test_subtest_name"
355     then
356         if diff -q "$file1" "$file2" >/dev/null ; then
357             test_ok_
358         else
359             testname=$this_test.$test_count
360             basename1=`basename "$file1"`
361             basename2=`basename "$file2"`
362             cp "$file1" "$testname.$basename1"
363             cp "$file2" "$testname.$basename2"
364             test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
365         fi
366     fi
367 }
368
369 # Like test_expect_equal, but takes two filenames.
370 test_expect_equal_file () {
371     exec 1>&6 2>&7              # Restore stdout and stderr
372     if [ -z "$inside_subtest" ]; then
373         error "bug in the test script: test_expect_equal_file without test_begin_subtest"
374     fi
375     inside_subtest=
376     test "$#" = 2 ||
377         error "bug in the test script: not 2 parameters to test_expect_equal_file"
378
379     test_diff_file_ "$1" "$2"
380 }
381
382 # Like test_expect_equal_file, but compare the part of the two files after the first blank line
383 test_expect_equal_message_body () {
384     exec 1>&6 2>&7              # Restore stdout and stderr
385     if [ -z "$inside_subtest" ]; then
386         error "bug in the test script: test_expect_equal_file without test_begin_subtest"
387     fi
388     test "$#" = 2 ||
389         error "bug in the test script: not 2 parameters to test_expect_equal_file"
390
391     expected=$(sed '1,/^$/d' "$1")
392     output=$(sed '1,/^$/d' "$2")
393     test_expect_equal "$expected" "$output"
394 }
395
396 # Like test_expect_equal, but takes two filenames. Fails if either is empty
397 test_expect_equal_file_nonempty () {
398     exec 1>&6 2>&7              # Restore stdout and stderr
399     if [ -z "$inside_subtest" ]; then
400         error "bug in the test script: test_expect_equal_file_nonempty without test_begin_subtest"
401     fi
402     inside_subtest=
403     test "$#" = 2 ||
404         error "bug in the test script: not 2 parameters to test_expect_equal_file_nonempty"
405
406     for file in "$1" "$2"; do
407         if [ ! -s "$file" ]; then
408             test_failure_ "Missing or zero length file: $file"
409             return $?
410         fi
411     done
412
413     test_diff_file_ "$1" "$2"
414 }
415
416 # Like test_expect_equal, but arguments are JSON expressions to be
417 # canonicalized before diff'ing.  If an argument cannot be parsed, it
418 # is used unchanged so that there's something to diff against.
419 test_expect_equal_json () {
420     local script output expected
421     # The test suite forces LC_ALL=C, but this causes Python 3 to
422     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
423     # override Python's stdio encoding defaults.
424     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
425     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
426         || echo "$1")
427     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
428         || echo "$2")
429     shift 2
430     test_expect_equal "$output" "$expected" "$@"
431 }
432
433 # Ensure that the argument is valid JSON data.
434 test_valid_json () {
435     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
436     test_expect_equal "$?" 0
437 }
438
439 # Sort the top-level list of JSON data from stdin.
440 test_sort_json () {
441     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
442         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
443 }
444
445 # test for json objects:
446 # read the source of test/json_check_nodes.py (or the output when
447 # invoking it without arguments) for an explanation of the syntax.
448 test_json_nodes () {
449         local output
450         exec 1>&6 2>&7          # Restore stdout and stderr
451         if [ -z "$inside_subtest" ]; then
452                 error "bug in the test script: test_json_eval without test_begin_subtest"
453         fi
454         inside_subtest=
455         test "$#" > 0 ||
456             error "bug in the test script: test_json_nodes needs at least 1 parameter"
457
458         if ! test_skip "$test_subtest_name"
459         then
460             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
461                 if [ "$?" = 0 ]
462                 then
463                         test_ok_
464                 else
465                         test_failure_ "$output"
466                 fi
467         fi
468 }
469
470 NOTMUCH_NEW () {
471     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
472 }
473
474 NOTMUCH_DUMP_TAGS () {
475     # this relies on the default format being batch-tag, otherwise some tests will break
476     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
477 }
478
479 notmuch_drop_mail_headers () {
480     $NOTMUCH_PYTHON -c '
481 import email, sys
482 msg = email.message_from_file(sys.stdin)
483 for hdr in sys.argv[1:]: del msg[hdr]
484 print(msg.as_string(False))
485 ' "$@"
486 }
487
488 notmuch_debug_sanitize () {
489     grep -v '^D.:'
490 }
491
492 notmuch_exception_sanitize () {
493     perl -pe 's,(A Xapian exception occurred at) .*?([^/]*[.]cc?):([0-9]*),\1 \2:XXX,'
494 }
495
496 notmuch_search_sanitize () {
497     notmuch_debug_sanitize | perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
498 }
499
500 notmuch_search_files_sanitize () {
501     notmuch_dir_sanitize |  sed 's/msg-[0-9][0-9][0-9]/msg-XXX/'
502 }
503
504 notmuch_dir_sanitize () {
505     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
506 }
507
508 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
509 notmuch_show_sanitize () {
510     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
511 }
512 notmuch_show_sanitize_all () {
513     notmuch_debug_sanitize | \
514     sed \
515         -e 's| filename:.*| filename:XXXXX|' \
516         -e 's| id:[^ ]* | id:XXXXX |' | \
517         notmuch_date_sanitize
518 }
519
520 notmuch_json_show_sanitize () {
521     sed \
522         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
523         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
524         -e 's|"filename": "signature.asc",||g' \
525         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
526         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
527         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
528 }
529
530 notmuch_sexp_show_sanitize () {
531     sed \
532         -e 's|:id "[^"]*"|:id "XXXXX"|g' \
533         -e 's|:Date "Sat, 01 Jan 2000 [^"]*0000"|:Date "GENERATED_DATE"|g' \
534         -e 's|:filename "signature.asc"||g' \
535         -e 's|:filename ("/[^"]*")|:filename ("YYYYY")|g' \
536         -e 's|:timestamp 9........|:timestamp 42|g' \
537         -e 's|:content-length [1-9][0-9]*|:content-length "NONZERO"|g'
538 }
539
540 notmuch_sexp_search_sanitize () {
541     sed -e 's|:thread "[^"]*"|:thread "XXX"|'
542 }
543
544 notmuch_emacs_error_sanitize () {
545     local command
546     command=$1
547     shift
548     for file in "$@"; do
549         echo "=== $file ==="
550         notmuch_debug_sanitize < "$file"
551     done | sed \
552         -e '/^$/d' \
553         -e '/^\[.*\]$/d' \
554         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
555 }
556
557 notmuch_date_sanitize () {
558     sed \
559         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
560 }
561
562 notmuch_uuid_sanitize () {
563     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
564 }
565
566 notmuch_built_with_sanitize () {
567     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
568 }
569
570 notmuch_config_sanitize () {
571     notmuch_dir_sanitize | notmuch_built_with_sanitize
572 }
573
574 notmuch_show_part () {
575     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
576 }
577
578 # End of notmuch helper functions
579
580 # Use test_set_prereq to tell that a particular prerequisite is available.
581 #
582 # The prerequisite can later be checked for by using test_have_prereq.
583 #
584 # The single parameter is the prerequisite tag (a simple word, in all
585 # capital letters by convention).
586
587 test_set_prereq () {
588         satisfied="$satisfied$1 "
589 }
590 satisfied=" "
591
592 test_have_prereq () {
593         case $satisfied in
594         *" $1 "*)
595                 : yes, have it ;;
596         *)
597                 ! : nope ;;
598         esac
599 }
600
601 declare -A test_missing_external_prereq_
602 declare -A test_subtest_missing_external_prereq_
603
604 # declare prerequisite for the given external binary
605 test_declare_external_prereq () {
606         local binary
607         binary="$1"
608         test "$#" = 2 && name=$2 || name="$binary(1)"
609
610         if ! hash $binary 2>/dev/null; then
611                 test_missing_external_prereq_["${binary}"]=t
612                 eval "
613 $binary () {
614         test_subtest_missing_external_prereq_[\"${name}\"]=t
615         false
616 }"
617         fi
618 }
619
620 # You are not expected to call test_ok_ and test_failure_ directly, use
621 # the text_expect_* functions instead.
622
623 test_ok_ () {
624         if test "$test_subtest_known_broken_" = "t"; then
625                 test_known_broken_ok_
626                 return
627         fi
628         test_success=$(($test_success + 1))
629         if test -n "$NOTMUCH_TEST_QUIET"; then
630                 return 0
631         fi
632         say_color pass "%-6s" "PASS"
633         echo " $test_subtest_name"
634 }
635
636 test_failure_ () {
637         print_test_description
638         if test "$test_subtest_known_broken_" = "t"; then
639                 test_known_broken_failure_ "$@"
640                 return
641         fi
642         test_failure=$(($test_failure + 1))
643         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
644         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
645         return 1
646 }
647
648 test_failure_message_ () {
649         say_color error "%-6s" "$1"
650         echo " $2"
651         shift 2
652         if [ "$#" != "0" ]; then
653                 echo "$@" | sed -e 's/^/        /'
654         fi
655         if test "$verbose" != "t"; then cat test.output; fi
656 }
657
658 test_known_broken_ok_ () {
659         test_reset_state_
660         test_fixed=$(($test_fixed+1))
661         say_color pass "%-6s" "FIXED"
662         echo " $test_subtest_name"
663 }
664
665 test_known_broken_failure_ () {
666         test_reset_state_
667         test_broken=$(($test_broken+1))
668         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
669                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
670         else
671                 test_failure_message_ "BROKEN" "$test_subtest_name"
672         fi
673         return 1
674 }
675
676 test_debug () {
677         test "$debug" = "" || eval "$1"
678 }
679
680 test_run_ () {
681         test_cleanup=:
682         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
683         eval >&3 2>&4 "$1"
684         eval_ret=$?
685         eval >&3 2>&4 "$test_cleanup"
686         return 0
687 }
688
689 test_skip () {
690         test_count=$(($test_count+1))
691         to_skip=
692         for skp in $NOTMUCH_SKIP_TESTS
693         do
694                 case $this_test.$test_count in
695                 $skp)
696                         to_skip=t
697                         break
698                 esac
699                 case $this_test_bare.$test_count in
700                 $skp)
701                         to_skip=t
702                         break
703                 esac
704         done
705         case "$to_skip" in
706         t)
707                 test_report_skip_ "$@"
708                 ;;
709         *)
710                 test_check_missing_external_prereqs_ "$@"
711                 ;;
712         esac
713 }
714
715 test_check_missing_external_prereqs_ () {
716         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
717                 say_color skip >&1 "missing prerequisites: "
718                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
719                 test_report_skip_ "$@"
720         else
721                 false
722         fi
723 }
724
725 test_report_skip_ () {
726         test_reset_state_
727         say_color skip >&3 "skipping test:"
728         echo " $@" >&3
729         say_color skip "%-6s" "SKIP"
730         echo " $1"
731 }
732
733 test_subtest_known_broken () {
734         test_subtest_known_broken_=t
735 }
736
737 test_expect_success () {
738         exec 1>&6 2>&7          # Restore stdout and stderr
739         if [ -z "$inside_subtest" ]; then
740                 error "bug in the test script: test_expect_success without test_begin_subtest"
741         fi
742         inside_subtest=
743         test "$#" = 1 ||
744         error "bug in the test script: not 1 parameters to test_expect_success"
745
746         if ! test_skip "$test_subtest_name"
747         then
748                 test_run_ "$1"
749                 run_ret="$?"
750                 # test_run_ may update missing external prerequisites
751                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
752                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
753                 then
754                         test_ok_
755                 else
756                         test_failure_ "$1"
757                 fi
758         fi
759 }
760
761 test_expect_code () {
762         exec 1>&6 2>&7          # Restore stdout and stderr
763         if [ -z "$inside_subtest" ]; then
764                 error "bug in the test script: test_expect_code without test_begin_subtest"
765         fi
766         inside_subtest=
767         test "$#" = 2 ||
768         error "bug in the test script: not 2 parameters to test_expect_code"
769
770         if ! test_skip "$test_subtest_name"
771         then
772                 test_run_ "$2"
773                 run_ret="$?"
774                 # test_run_ may update missing external prerequisites,
775                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
776                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
777                 then
778                         test_ok_
779                 else
780                         test_failure_ "exit code $eval_ret, expected $1" "$2"
781                 fi
782         fi
783 }
784
785 # This is not among top-level (test_expect_success)
786 # but is a prefix that can be used in the test script, like:
787 #
788 #       test_expect_success 'complain and die' '
789 #           do something &&
790 #           do something else &&
791 #           test_must_fail git checkout ../outerspace
792 #       '
793 #
794 # Writing this as "! git checkout ../outerspace" is wrong, because
795 # the failure could be due to a segv.  We want a controlled failure.
796
797 test_must_fail () {
798         "$@"
799         test $? -gt 0 -a $? -le 129 -o $? -gt 192
800 }
801
802 # test_cmp is a helper function to compare actual and expected output.
803 # You can use it like:
804 #
805 #       test_expect_success 'foo works' '
806 #               echo expected >expected &&
807 #               foo >actual &&
808 #               test_cmp expected actual
809 #       '
810 #
811 # This could be written as either "cmp" or "diff -u", but:
812 # - cmp's output is not nearly as easy to read as diff -u
813 # - not all diff versions understand "-u"
814
815 test_cmp () {
816         $GIT_TEST_CMP "$@"
817 }
818
819 # This function can be used to schedule some commands to be run
820 # unconditionally at the end of the test to restore sanity:
821 #
822 #       test_expect_success 'test core.capslock' '
823 #               git config core.capslock true &&
824 #               test_when_finished "git config --unset core.capslock" &&
825 #               hello world
826 #       '
827 #
828 # That would be roughly equivalent to
829 #
830 #       test_expect_success 'test core.capslock' '
831 #               git config core.capslock true &&
832 #               hello world
833 #               git config --unset core.capslock
834 #       '
835 #
836 # except that the greeting and config --unset must both succeed for
837 # the test to pass.
838
839 test_when_finished () {
840         test_cleanup="{ $*
841                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
842 }
843
844 test_done () {
845         GIT_EXIT_OK=t
846         test_results_dir="$TEST_DIRECTORY/test-results"
847         mkdir -p "$test_results_dir"
848         test_results_path="$test_results_dir/$this_test"
849
850         printf %s\\n \
851                 "success $test_success" \
852                 "fixed $test_fixed" \
853                 "broken $test_broken" \
854                 "failed $test_failure" \
855                 "total $test_count" \
856             > $test_results_path
857
858         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
859
860         if [ "$test_failure" = "0" ]; then
861             if [ "$test_broken" = "0" ]; then
862                 rm -rf "$remove_tmp"
863             fi
864             exit 0
865         else
866             exit 1
867         fi
868 }
869
870 test_python () {
871     # Note: if there is need to print debug information from python program,
872     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
873     PYTHONPATH="$NOTMUCH_BUILDDIR/bindings/python-cffi/build/stage:$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
874         $NOTMUCH_PYTHON -B - > OUTPUT
875 }
876
877 test_C () {
878     local exec_file test_file
879     exec_file="test${test_count}"
880     test_file="${exec_file}.c"
881     cat > ${test_file}
882     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
883     echo "== stdout ==" > OUTPUT.stdout
884     echo "== stderr ==" > OUTPUT.stderr
885     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
886     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize | notmuch_debug_sanitize > OUTPUT
887 }
888
889 test_private_C () {
890     local exec_file test_file
891     exec_file="test${test_count}"
892     test_file="${exec_file}.c"
893     echo '#include <notmuch-private.h>' > ${test_file}
894     cat >> ${test_file}
895     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -I${NOTMUCH_SRCDIR}/util -I${NOTMUCH_SRCDIR}/compat ${NOTMUCH_GMIME_CFLAGS} -o ${exec_file} ${test_file} ${NOTMUCH_BUILDDIR}/lib/libnotmuch.a ${NOTMUCH_GMIME_LDFLAGS} ${NOTMUCH_XAPIAN_LDFLAGS} ${NOTMUCH_BUILDDIR}/util/libnotmuch_util.a ${NOTMUCH_SFSEXP_LDFLAGS} ${NOTMUCH_BUILDDIR}/parse-time-string/libparse-time-string.a -ltalloc -lstdc++
896     echo "== stdout ==" > OUTPUT.stdout
897     echo "== stderr ==" > OUTPUT.stderr
898     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
899     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize | notmuch_debug_sanitize > OUTPUT
900 }
901
902 make_shim () {
903     local base_name test_file shim_file
904     base_name="$1"
905     test_file="${base_name}.c"
906     shim_file="${base_name}.so"
907     cat > ${test_file}
908     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
909 }
910
911 notmuch_with_shim () {
912     local base_name shim_file
913     base_name="$1"
914     shift
915     shim_file="${base_name}.so"
916     LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} notmuch-shared "$@"
917 }
918
919 # Creates a script that counts how much time it is executed and calls
920 # notmuch.  $notmuch_counter_command is set to the path to the
921 # generated script.  Use notmuch_counter_value() function to get the
922 # current counter value.
923 notmuch_counter_reset () {
924         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
925         if [ ! -x "$notmuch_counter_command" ]; then
926                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
927                 cat >"$notmuch_counter_command" <<EOF || return
928 #!/bin/sh
929
930 read count < "$notmuch_counter_state_path"
931 echo \$((count + 1)) > "$notmuch_counter_state_path"
932
933 exec notmuch "\$@"
934 EOF
935                 chmod +x "$notmuch_counter_command" || return
936         fi
937
938         echo 0 > "$notmuch_counter_state_path"
939 }
940
941 # Returns the current notmuch counter value.
942 notmuch_counter_value () {
943         if [ -r "$notmuch_counter_state_path" ]; then
944                 read count < "$notmuch_counter_state_path"
945         else
946                 count=0
947         fi
948         echo $count
949 }
950
951 test_reset_state_ () {
952         test -z "$test_init_done_" && test_init_
953
954         test_subtest_known_broken_=
955         test_subtest_missing_external_prereq_=()
956 }
957
958 # called once before the first subtest
959 test_init_ () {
960         test_init_done_=t
961
962         # skip all tests if there were external prerequisites missing during init
963         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
964 }
965
966
967 # Where to run the tests
968 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
969
970 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
971
972 # Use -P to resolve symlinks in our working directory so that the cwd
973 # in subprocesses like git equals our $PWD (for pathname comparisons).
974 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
975
976 if test "$verbose" = "t"
977 then
978         exec 4>&2 3>&1
979 else
980         exec 4>test.output 3>&4
981 fi
982
983 for skp in $NOTMUCH_SKIP_TESTS
984 do
985         to_skip=
986         for skp in $NOTMUCH_SKIP_TESTS
987         do
988                 case "$this_test" in
989                 $skp)
990                         to_skip=t
991                         break
992                 esac
993                 case "$this_test_bare" in
994                 $skp)
995                         to_skip=t
996                         break
997                 esac
998         done
999         case "$to_skip" in
1000         t)
1001                 say_color skip >&3 "skipping test $this_test altogether"
1002                 say_color skip "skip all tests in $this_test"
1003                 test_done
1004         esac
1005 done
1006
1007 # Provide an implementation of the 'yes' utility
1008 yes () {
1009         if test $# = 0
1010         then
1011                 y=y
1012         else
1013                 y="$*"
1014         fi
1015
1016         while echo "$y"
1017         do
1018                 :
1019         done
1020 }
1021
1022 # Fix some commands on Windows
1023 case $(uname -s) in
1024 *MINGW*)
1025         # Windows has its own (incompatible) sort and find
1026         sort () {
1027                 /usr/bin/sort "$@"
1028         }
1029         find () {
1030                 /usr/bin/find "$@"
1031         }
1032         sum () {
1033                 md5sum "$@"
1034         }
1035         # git sees Windows-style pwd
1036         pwd () {
1037                 builtin pwd -W
1038         }
1039         # no POSIX permissions
1040         # backslashes in pathspec are converted to '/'
1041         # exec does not inherit the PID
1042         ;;
1043 *)
1044         test_set_prereq POSIXPERM
1045         test_set_prereq BSLASHPSPEC
1046         test_set_prereq EXECKEEPSPID
1047         ;;
1048 esac
1049
1050 test -z "$NO_PERL" && test_set_prereq PERL
1051 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1052
1053 # test whether the filesystem supports symbolic links
1054 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1055 rm -f y
1056
1057 # declare prerequisites for external binaries used in tests
1058 test_declare_external_prereq dtach
1059 test_declare_external_prereq emacs
1060 test_declare_external_prereq ${TEST_EMACSCLIENT}
1061 test_declare_external_prereq ${TEST_GDB}
1062 test_declare_external_prereq gpg
1063 test_declare_external_prereq openssl
1064 test_declare_external_prereq gpgsm
1065 test_declare_external_prereq ${NOTMUCH_PYTHON}
1066 test_declare_external_prereq xapian-metadata
1067 test_declare_external_prereq xapian-delve